/*
#####################
# remean
# Entfernt zu helle oder zu dunkle frames
*# 2017 by -=CMB=-
#####################
*/

#include <iostream>
#include <fstream>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <termios.h>
#include <stropts.h>
#include <sys/ioctl.h>	// weil wegen fur FIONREAD
#include <time.h>
#include <sys/select.h>
#include <sys/sysinfo.h>


using namespace std;

char version[8] = "0.1";
int mean;				// Helligkeits-Mittelwert
char cfmean[128];		// Mittelwert, gelesen aus der temporaeren Datei
int fmean;				// Mittelwert, atoi-konvertiert aus der temporaeren Datei
char cmdline[4096];		// Kommandozeile für externen Programmaufruf

int main(int argc, char *argv[])
{
	
	cout << "\n\nremean V" << version << "\n2017 by -=CMB=-" << "\nentfernt mit Hilfe von imagemagick Bilder unter- oder oberhalb eines vorgegebenen Helligkeitsmittelwertes" << endl;
//################
//# Kommandozeile parsen
//#
	if (argc != 4)
		{
			cout << "\nSyntax : remframe {Mittelwert} {a oder b} {dateiname}\n\n";
			return 11;
			}
			
	mean = atoi(argv[1]);	// erstes Argument ist Mittelwert

	if ((*argv[2] != 'a') && (*argv[2] != 'b')) // errorhandling
	{
		cout << "\nFalscher Programmaufruf !\n\n";
		return 20;
	} 
	

//	#### DEBUG
//	cout << "\n\nMittelwert : " << mean << "\tSelektionsrichtung : " << selektionsrichtg << "\tDateiname : " << argv[3] << endl;	
	
// ##########
// # identify von imagemagick aufrufen und machen lassen
	
	strcpy (cmdline, "identify -format \"%[mean]\" ");
	strcat (cmdline, argv[3]);
	strcat (cmdline, " > mittelwert");

// #### DEBUG	
//	cout << "\ncmdline : " << cmdline << endl;

	system (cmdline);	// jetzt aber
	
	
// #### Datei einlesen in der der Mittelwert steht
// #	
	ifstream mwert ("mittelwert");
	if (!mwert)
	{
		cout << "\n\nKann temporaere Datei nicht lesen !\n\n";
		return 30;
	}
	
	mwert.getline(cfmean, 16);
	
	fmean = atoi(cfmean);	// jetzt haben wir den Mittelwert als int-Variable vorliegen


// #### Bilder UNTERHALB des Vorgabewertes entfernen
	if (*argv[2] == 'b')
	{
		if (mean > fmean)
		{
			cout << "\n " << mean << " zu " << fmean << " Datei " << argv[3] << " wird gelöscht !!!\n";
			strcpy (cmdline, "rm ");
			strcat (cmdline, argv[3]);
			system (cmdline); 
		}
		else 
		{
			cout << "\n " << mean << " zu " << fmean << " Datei entspricht Kriterien\n";
		}
	}

// #### Bilder OBERHALB des Vorgabewertes entfernen
	else if (*argv[2] == 'a')
	{
		if (mean < fmean)
		{
			cout << "\n " << mean << " zu " << fmean << " Datei " << argv[3] << " wird gelöscht !!!\n";
			strcpy (cmdline, "rm ");
			strcat (cmdline, argv[3]);
			system (cmdline); 
		}
		else 
		{
			cout << "\n " << mean << " zu " << fmean << " Datei entspricht Kriterien\n";
		}
	}
	
	 		
	mwert.close();		
	return 0;				// alles ist gut
}	// main-Schleife
